#include <libirobot/SerialControl.h>
#include "DriveRobot.h"
#include <libirobot/Drive.h>
DriveRobot *robot;

#ifndef __AVR__
#include <error.h>
#include <signal.h>
#include <stdlib.h>

void quit(int)
{
	Drive *d = robot->getDrive();
	d->move(0);
	exit(0);
}

#endif

int main ( int argc, char* argv[] )
{
#ifndef __AVR__
	if (argc < 2)
		error(1, 0, "Usage: %s [serial-device]", argv[0]);
#endif
	robot = new DriveRobot( argv[1] );
#ifndef __AVR__
	struct sigaction handler;
	handler.sa_handler = quit;
	sigaction(SIGINT, &handler, 0);
#endif
    return robot->run();
}

#else

int main( int argc, char* argv[] )
{
    DriveRobot *robot = new DriveRobot(argv[1]);
    return robot->run();
}

#endif
