#include "StraightRobot.h"
#include <libirobot/StateMachine.h>
#include <libirobot/Robot.h>
#include <libirobot/states/DriveState.h>
#include <libirobot/transitions/ValueSensorTransition.h>

#define TWENTYFIVE_FEET 3048/2*5

StraightRobot::StraightRobot(char* ttyDevice)
	: Robot(ttyDevice)
{
	setMode(Safe);
	setAutoUpdate( Sensor::All, true );
	m_machine = new StateMachine(this);

	DriveState* drive = new DriveState(m_machine, Drive::Fast, 1250);
	DriveState* stop = new DriveState(m_machine, 0, 0);

    ValueSensorTransition* waitToFinish = new ValueSensorTransition(stop, Sensor::Distance, (ValueSensorTransition::Comparison)(ValueSensorTransition::GreaterThan | ValueSensorTransition::Total), TWENTYFIVE_FEET);

	drive->addTransition(waitToFinish);
}

void
StraightRobot::loop()
{
	m_machine->loop();
}

