#include <Song.h>
#include <stdlib.h>

using namespace iRobot;

Song::Song()
{
}

Song::Song(uint8_t length)
{
	m_length = length;
	m_notes = (Note*)calloc(length, sizeof(Note*));
}

Song::Song(uint8_t length, const Note notes[])
{
	m_length = length;
	m_notes = (Note*)calloc(length, sizeof(Note*));
	for(int i = 0;i < length;i++) {
		m_notes[i] = notes[i];
	}
}

Song::~Song()
{
	free(m_notes);
}

void
Song::setLength(uint8_t length)
{
	m_length = length;
	m_notes = (Note*)realloc(m_notes, sizeof(Note*)*length);
}

void
Song::setNotes(uint8_t length, const Note notes[])
{
	setLength(length);
	for(int i = 0;i<length;i++)
		m_notes[i] = notes[i];
}

void
Song::setNotePitch(int note, uint8_t pitch)
{
	m_notes[note].pitch = pitch;
}

void
Song::setNoteLength(int note, uint8_t length)
{
	m_notes[note].length = length;
}

void
Song::setNote(int noteNum, const Note note)
{
	m_notes[noteNum] = note;
}

uint8_t
Song::getLength() const
{
	return m_length;
}

Song::Note
Song::getNote(int note) const
{
	return m_notes[note];
}
