#ifndef BUMPANDDROPSENSOR_H
#define BUMPANDDROPSENSOR_H

#include <libirobot/Sensor.h>

namespace iRobot
{

/**
 * Sensor for bumper bumps and drop sensor drops.
 */
class BumpAndDropSensor : public Sensor
{

    public:
		/**
		 * Possible values of the sensor's flags
		 * @see flags()
		 */
        typedef enum {
            None = 0,
            BumpRight = 1,
            BumpLeft = 2,
            WheelRight = 4,
            WheelLeft = 8,
            WheelCaster = 16,
            BumpAny = 3,
			DropAny = 28
        } Sensor;
		/**
		 * Returns the flags set by the bump and wheel drop sensors
		 * @see Sensor
		 */
        uint8_t flags() const;
    protected:
        void update ( uint8_t data[] );
    private:
        uint8_t m_flags;

};

}

#endif
