#ifndef CARGODIGITALINPUTSENSOR_H
#define CARGODIGITALINPUTSENSOR_H

#include <libirobot/Sensor.h>

namespace iRobot
{

/**
 * Sensor for the digital inputs in the cargo bay
 */
class CargoDigitalInputSensor : public Sensor
{
    public:
		/**
		 * Bit values for each pin
		 */
        typedef enum {
            Input0 = 1,
            Input1 = 2,
            Input2 = 4,
            Input3 = 8,
            Baud = 16
        } Pin;
		/**
		 * Returns the value of the given pin
		 * @param p Pin to return
		 */
        bool value ( Pin p ) const;
    protected:
        void update ( uint8_t data[] );
    private:
        uint8_t m_value;
};

}

#endif

