#ifndef CHARGESOURCESENSOR_H
#define CHARGESOURCESENSOR_H

#include <libirobot/Sensor.h>

namespace iRobot
{

/**
 * Charging sources available to the robot
 */
class ChargeSourceSensor : public Sensor
{
    public:
		/**
		 * Bit values for the sources available
		 */
        typedef enum {
            Internal = 1,
            Base = 2
        } Source;
		/**
		 * Returns the available sources
		 */
        uint8_t sources() const;
    protected:
        void update ( uint8_t data[] );
    private:
        uint8_t m_flags;
};

}

#endif
