#ifndef CHARGESTATESENSOR_H
#define CHARGESTATESENSOR_H

#include <libirobot/Sensor.h>

namespace iRobot
{

/**
 * The state of the robot's internal charger
 */
class ChargeStateSensor : public Sensor
{
    public:
		/**
		 * Possible states of charging
		 */
        typedef enum {
			/**
			 * Not charging
			 */
            NotCharging = 0,
			/**
			 * Reconditioning charging
			 */
            Reconditioning = 1,
			/**
			 * Charge complete!
			 */
            Full = 2,
			/**
			 * Trickle charge
			 */
            Trickle = 3,
			/**
			 * Waiting to start charging
			 */
            Waiting = 4,
			/**
			 * Internal charger fault
			 */
            Fault = 5
        } State;
		/**
		 * Returns the current state of the charger
		 */
        State state() const;
    protected:
        void update ( uint8_t data[] );
    private:
        State m_state;
};

}

#endif
