#ifndef MODESENSOR_H
#define MODESENSOR_H

#include <libirobot/Sensor.h>

namespace iRobot
{

/**
 * The robot's operating mode
 * @see Robot::setMode()
 * @see Robot::Mode
 */
class ModeSensor : public Sensor
{
    public:
		/**
		 * @see Robot::Mode
		 */
        typedef enum {
            Off = 0,
            Passive = 1,
            Safe = 2,
            Full = 3
        } Mode;
		/**
		 * Returns the robot's current mode
		 *
		 * Not the same value as Robot::Mode
		 */
        Mode mode() const;
    protected:
        void update ( uint8_t data[] );
    private:
        Mode m_mode;
};

}

#endif

