#ifndef OVERCURRENTSENSOR_H
#define OVERCURRENTSENSOR_H

#include <libirobot/Sensor.h>

namespace iRobot
{

/**
 * State of the low side driver and two wheel overcurrent sensors
 * FIXME: wtf is the 'low side driver'?
 */
class OvercurrentSensor : public Sensor
{
    public:
		/**
		 * @see flags()
		 */
        typedef enum {
            LeftWheel = 0x10,
            RightWheel = 0x08,
            LD2 = 0x04,
            LD0 = 0x02,
            LD1 = 0x01
        } Flag;
		/**
		 * Returns true if the left wheel has overcurrent
		 */
        bool leftWheel() const;
		/**
		 * Returns true if the right wheel has overcurrent
		 */
        bool rightWheel() const;
        bool ld0() const;
        bool ld1() const;
        bool ld2() const;
		/**
		 * The byte that contains all subsensors in one value
		 */
        uint8_t flags() const;
    protected:
        void update ( uint8_t data[] );
    private:
        uint8_t m_flags;
};

}

#endif

