#include "ValueSensor.h"

#include "Debug.h"

using namespace iRobot;

ValueSensor::ValueSensor()
{
	m_total = 0;
}

int16_t
ValueSensor::value() const
{
    return m_value;
}

void
ValueSensor::resetTotal()
{
    m_total = 0;
}

void
ValueSensor::update ( uint8_t data[] )
{
    m_value = (int)( data[0] << 8 ) | data[1];
    m_total+=m_value;
}

int
ValueSensor::total() const
{
	return m_total;
}

