#include "DriveState.h"
#include "Robot.h"
#include "Drive.h"

using namespace iRobot;

DriveState::DriveState(StateMachine* machine, int speed, int radius)
    : State(machine),
      m_speed(speed),
      m_radius(radius)
{
}

DriveState::DriveState(StateMachine* machine, Drive::Speed speed, Drive::TurnDirection direction)
    : State(machine),
      m_speed((int)speed),
      m_radius((int)direction)
{
}

DriveState::DriveState(StateMachine* machine, Drive::Speed speed, int radius)
    : State(machine),
      m_speed((int)speed),
      m_radius(radius)
{
}

DriveState::DriveState(StateMachine* machine, int speed, Drive::TurnDirection direction)
    : State(machine),
      m_speed(speed),
      m_radius((int)direction)
{
}

DriveState::~DriveState()
{
    
}

void
DriveState::loop()
{
    getRobot()->getDrive()->move(m_speed, m_radius);
}
