#include "BumpTransition.h"
#include "State.h"
#include "Robot.h"
#include "Sensor.h"
#include "sensors/BumpAndDropSensor.h"

using namespace iRobot;

BumpTransition::BumpTransition(State* next, BumpAndDropSensor::Sensor type)
    : StateTransition(next),
      m_type(type)
{
    getRobot()->setAutoUpdate(Sensor::All, true);
}

BumpTransition::~BumpTransition()
{
}

bool
BumpTransition::test()
{
    BumpAndDropSensor* sensor = (BumpAndDropSensor*)getRobot()->getSensor(Sensor::BumpsAndDrops);
    if (m_type == BumpAndDropSensor::None && !(sensor->flags() & BumpAndDropSensor::BumpAny))
        return true;
    return (sensor->flags() & m_type);
}
