#include "ValueSensorTransition.h"

#include "Debug.h"

#include "Robot.h"

using namespace iRobot;

ValueSensorTransition::ValueSensorTransition(State* next, Sensor::SensorID sensor, Comparison type, int16_t value)
    : StateTransition(next),
      m_sensor(sensor),
      m_value(value),
      m_compare(type)
{
}

ValueSensorTransition::~ValueSensorTransition()
{
}

void
ValueSensorTransition::parentEntered()
{
    if (m_compare & ResetOnEntry) {
		//ValueSensor* sensor = static_cast<ValueSensor*>(getRobot()->getSensor(m_sensor));
        m_total = 0;
		/*if (sensor)
	        sensor->resetTotal();*/
        IROBOT_DEBUG("Resetting sensor total");
    }
}

bool
ValueSensorTransition::test()
{
    ValueSensor* sensor = static_cast<ValueSensor*>(getRobot()->getSensor(m_sensor));
    if (sensor) {
        m_total+= sensor->value();
        int testVal;
        if (m_compare & Total)
            testVal = m_total;
        else
            testVal = sensor->value();

        IROBOT_DEBUG("Testing " << testVal << " (" << (int)m_compare << ") " << m_value);
        if (m_compare == NotEqual)
            return testVal != m_value;
        bool ret = true;
        if (m_compare & EqualTo)
            ret &= testVal == m_value;
        if (m_compare & LessThan)
            ret &= testVal < m_value;
        if (m_compare & GreaterThan)
            ret &= testVal > m_value;
        return ret;
    }
    return false;
}
