#ifndef VALUESENSORTRANSITION_H
#define VALUESENSORTRANSITION_H

#include <libirobot/StateTransition.h>
#include <libirobot/Sensor.h>
#include <libirobot/sensors/ValueSensor.h>

namespace iRobot
{
    
class ValueSensorTransition : public StateTransition {
    public:
        typedef enum {
            NotEqual = 0,
            EqualTo = 1,
            LessThan = 2,
            GreaterThan = 4,
            Total = 8,
            ResetOnEntry = 16
        } Comparison;
        ValueSensorTransition(State* next, Sensor::SensorID sensor, Comparison type, int16_t value);
        ~ValueSensorTransition();
        void parentEntered();
        bool test();
    private:
        Sensor::SensorID m_sensor;
        int16_t m_value;
        int16_t m_total;
        Comparison m_compare;
};
    
}

#endif
